//+------------------------------------------------------------------+
//|                                                       .mq4 |
//|                      Copyright  2009, MetaQuotes Software Corp. |
//|                                       http://www.metaquotes.net/ |
//+------------------------------------------------------------------+

extern double TakeProfit = 12,
              StopLoss = 12,
              Lots = 0.1,
              TrailingStop = 0;


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int start()
  {
   double upFr=0, downFr=0,sum, MaCurrent1, MaCurrent2, 
          MaCurrent3, MaPrevious1, MaPrevious2, MaPrevious3;
   int cnt, ticket, total, shift = 0;

   
// initial data checks
// it is important to make sure that the expert works with a normal
// chart and the user did not make any mistakes setting external 
// variables (Lots, StopLoss, TakeProfit, 
// TrailingStop) in our case, we check TakeProfit
// on a chart of less than 100 bars
   if(Bars<100)
     {
      Print("bars less than 100");
      return(0);  
     }
   if(TakeProfit<10)
     {
      Print("TakeProfit less than 10");
      return(0);  // check TakeProfit
     }
// to simplify the coding and speed up access
// data are put into internal variables

//   
    MaCurrent1 = iMA(NULL,0,1,0,MODE_SMMA,PRICE_TYPICAL,0);
    MaCurrent2 = iMA(NULL,0,3,0,MODE_SMMA,PRICE_TYPICAL,0);
    MaCurrent3 = iMA(NULL,0,7,0,MODE_LWMA,PRICE_WEIGHTED,0);
    MaPrevious1 = iMA(NULL,0,1,0,MODE_SMMA,PRICE_TYPICAL,1);
    MaPrevious2 = iMA(NULL,0,3,0,MODE_SMMA,PRICE_TYPICAL,1);
    MaPrevious3 = iMA(NULL,0,7,0,MODE_LWMA,PRICE_WEIGHTED,1);

//  
    while(NormalizeDouble(sum, Digits) == 0)
    {
    upFr = iFractals (NULL, 0, MODE_UPPER, shift);
    downFr = iFractals (NULL, 0, MODE_LOWER, shift);
    sum = upFr + downFr;
    shift++;
    }

// ____
   total=OrdersTotal();
   if(total<1) 
     {
      // no opened orders identified
      if(AccountFreeMargin()<(1000*Lots))
        {
         Print("We have no money. Free Margin = ", AccountFreeMargin());
         return(0);  
        }
      //    buy
      if(upFr > 0 && MaPrevious1 < MaPrevious2 && MaPrevious2 < MaPrevious3 && MaCurrent1 > MaCurrent2 && ((MaCurrent1/MaCurrent2-1)*100) > 10 &&
        MaCurrent1 > MaPrevious1 && MaCurrent3 > MaCurrent1 && MaCurrent3 > MaCurrent2)
        {
         ticket=OrderSend(Symbol(),OP_BUY,Lots,Ask,3,Ask-StopLoss*Point,Ask+TakeProfit*Point,"",16384,0,Green);
         if(ticket>0)
           {
            if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) Print("BUY order opened : ",OrderOpenPrice());
           }
         else Print("Error opening BUY order : ",GetLastError()); 
         return(0); 
        }
      //    sell
      if(downFr > 0 && MaPrevious1 > MaPrevious2 && MaCurrent1 > MaCurrent2 && ((MaCurrent1/MaCurrent2-1)*100) > 15 &&
         MaCurrent3 < MaCurrent1 && MaCurrent3 < MaCurrent2)
        {
         ticket=OrderSend(Symbol(),OP_SELL,Lots,Bid,3, Bid+StopLoss*Point, Bid-TakeProfit*Point,"",16384,0,Red);
         if(ticket>0)
           {
            if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) Print("SELL order opened : ",OrderOpenPrice());
           }
         else Print("Error opening SELL order : ",GetLastError()); 
         return(0); 
        }
      return(0);
     }
   // it is important to enter the market correctly, 
   // but it is more important to exit it correctly...   
   for(cnt=0;cnt<total;cnt++)
     {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if(OrderType()<=OP_SELL &&   // check for opened position 
         OrderSymbol()==Symbol())  // check for symbol
        {
         if(OrderType()==OP_BUY)   // long position is opened
           {
            // check for trailing stop
            if(TrailingStop>0)  
              {                 
               if(Bid-OrderOpenPrice()>Point*TrailingStop)
                 {
                  if(OrderStopLoss()<Bid-Point*TrailingStop)
                    {
                     OrderModify(OrderTicket(),OrderOpenPrice(),Bid-Point*TrailingStop,OrderTakeProfit(),0,Green);
                     return(0);
                    }
                 }
              }
           }
         else // go to short position
           {
            // check for trailing stop
            if(TrailingStop>0)  
              {                 
               if((OrderOpenPrice()-Ask)>(Point*TrailingStop))
                 {
                  if((OrderStopLoss()>(Ask+Point*TrailingStop)) || (OrderStopLoss()==0))
                    {
                     OrderModify(OrderTicket(),OrderOpenPrice(),Ask+Point*TrailingStop,OrderTakeProfit(),0,Red);
                     return(0);
                    }
                 }
              }
           }
        }
     }
   return(0);
  }
// the end.